lParameters cpBase, cpFile

On Error Do pGenDBC_Error With Message(), LineNo()

Set Blink Off
Set Century On             &&     
Set Confirm Off            &&         
Set Consol Off             &&      
Set Cursor On              &&     
Set Date to German         &&   ..
Set Decimals To 2          &&    
Set Deleted On             &&    ,   
Set Escape On              &&      ESC
Set Exact Off              &&   
Set Hour To 24
Set Talk Off
Set Safety Off             &&      
Set Procedure To

Public cpFullDatabase, cpNameDatabase, cpPathDataBase, cpOutFile, cpOldCurrent
Store '' To cpFullDatabase, cpOutFile
cpOldCurrent = Sys (5) + CurDir ()

*     
If pCount () > 0
  If pCount () = 2
    If Type ('cpBase') # 'C' Or Type ('cpFile') # 'C'
      Do pErrorMessage With '    '
      Do pGenExit With .F.
      Return
    Else
      cpFullDatabase = cpBase
      cpOutFile      = cpFile
    EndIf
  Else
    Do pErrorMessage With ' ...' + Chr (13) + '  : DO MyGenDBC With " ", " "'
    Do pGenExit With .F.
    Return
  EndIf
EndIf

*        -
cpFullDataBase = Upper (fGetBase (cpFullDataBase)) &&     
If Empty (cpFullDataBase)
  Do pGenExit With .F.
  Return
EndIf
cpNameDatabase = SubStr (cpFullDatabase, Rat ("\", cpFullDatabase) + 1) &&   
cpPathDataBase = SubStr (cpFullDatabase, 1, Rat ("\", cpFullDatabase))  &&    
cpOutFile      = fGetOutFile (cpOutFile) && -
If Empty (cpOutFile)
  Do pGenExit With .F.
  Return
EndIf

Compile DataBase (cpFullDatabase)

*       ,    
Public npTablesCount, cpTablesString, cpTablesString1, cpTablesString2, cpTablesString3, cpIndexExist, cpTablesCP, cpTablesCP1, cpTablesCP2
Local llOpened, i
llOpened = DBUsed (cpFullDatabase)
If !llOpened
  Open DataBase (cpFullDatabase)
EndIf
Set DataBase To (cpFullDatabase)
npTablesCount  = ADBObjects (aAll_Tables, 'Table') &&   
cpTablesString = ''
cpTablesString1 = ''
cpTablesString2 = ''
cpTablesString3 = ''
For i = 1 To npTablesCount
  Do Case
    Case i >= 0 And i <= 30
      cpTablesString1 = cpTablesString1 + aAll_Tables [i] + ';'
    Case i >= 31 And i <= 60
      cpTablesString2 = cpTablesString2 + aAll_Tables [i] + ';'
    OtherWise
      cpTablesString3 = cpTablesString3 + aAll_Tables [i] + ';'
  EndCase
Next
If !llOpened
  Close DataBases
EndIf
Release llOpened, i

cpIndexExist = fGetIndexes ()   &&     
cpTablesCP1  = SubStr (fGetCodePages (), 1, 255) &&     ( 1-   255)
cpTablesCP2  = SubStr (fGetCodePages (), 256) &&     ( 255-    )

Set TextMerge To (cpOutFile)
Set TextMerge On

Set Default To (cpPathDataBase)
Do pMakeTitle             &&  
Do pMakeOk_Pr_Base        &&   fOk_Pr_Base
Do pMakeZaprosExit        &&   pZaprosExit
Do pMakeAttrib            &&   fGetAttrib
Do pMakePrBase            &&   pPrBase
Do pMakeRecoverBase       &&   fRecoverBase
Do pMakeFilesExists       &&   fFilesExists
Do pMakeYesSboy           &&   fYesSboy
Do pMakeVersion           &&   fVersion
Do pMakeIndexes           &&   
Do pMakeConnections       &&   fMakeConnections
Do pMakeViews             &&   fMakeViews
Do pMakeRelations         &&   fMakeRelations
Do pMakeRI                &&    
Do pMakeNormalAllStruct   &&   fNormalAllStruct
Do pMakeNormalAllIndex    &&   fNormalAllIndex
Do pMakeValidStructure    &&   fValidStructure
Do pMakeStrucToArray      &&   pStrucToArray
Do pMakeGetStructure      &&   fGetStructure
Do pMakeWaitRecover       &&   pWaitRecover
Do pMakeBaseRecovering    &&   fBaseRecovering
Do pMakeCreateTable       &&   fCreateTable
Do pMakeGetStrBetweenSimv &&   fGetStrBetweenSimv
Do pMakeCPZero            &&   fCP_Zero
Do pMakePCPZero           &&   pCP_Zero
Do pMakeErrorEvents       &&   pErrorEvents
Do pMakeClasses           &&  
Do pGenExit With .T.      &&    
Return
*----------------------   --------------------------------

*-----------------------------------------------------------------------
*   pMakeTitle
*  :
*       
Procedure pMakeTitle
  \\*-----------------------------------------------------------------------
  \*     MyGenDBC.prg
  \*      :
  \*   cPathBase   -    
  \*   cVersion    -  
  \* !!!
  \*           
Return

*-----------------------------------------------------------------------
*   pMakeAttrib
*  :
*           
Procedure pMakeAttrib
  \*-----------------------------------------------------------------------
  \*  fGetAttrib
  \* :
  \*        
  \*  :
  \*     0 -    
  \*    -3 -  ,   "  "
  \Function fGetAttrib
  \  Local i, nlCount, llOK
  \  nlCount = aDir (arTmp, cPathBase + '*.*')
  \  llOK = .T.
  \  If nlCount > 0
  \    For i = 1 To nlCount
  \      If arTmp [i, 5] = 'R'
  \        llOK = .F.
  \        Exit
  \      EndIf
  \    Next
  \    Release arTmp
  \  EndIf
  \  If !llOK
  \    = MessageBox ('  ' + cPathBase + '     "  ".        .', 48, '')
  \    Return -3
  \  EndIf
  \Return 0
Return

*-----------------------------------------------------------------------
*   pMakeOk_Pr_Base
*  :
*             
Procedure pMakeOk_Pr_Base
  \*-----------------------------------------------------------------------
  \*  fOk_Pr_Base
  \* :
  \*           
  \*  :
  \*     0 - 
  \*    -1 -    
  \*    -2 -   .DBC  .DCT  
  \*    -3 -     
  \*    -4 -        
  \*    -5 -       
  \*   -10 -         /
  \*   -20 -       ESC
  \Function fOk_Pr_Base
  \  Public oLoad, cpTablesString, cpTablesString1, cpTablesString2, cpTablesString3, npTablesCount, cpIndexExist, cpTablesCP, cpTablesCP1, cpTablesCP2,;
  \         lpYesSboy, npRetProv, cpRecoverFile, cpRegFiles, npHRec, nPrError
  \  npTablesCount  = <<npTablesCount>>
  \  If npTablesCount = 0
  \    Return -5
  \  EndIf
  \  Local nlRet, clEscape, llOpened
  \  clEscape      = Set ('Escape')
  \  cpRecoverFile = 'recover_.tmp'
  \  cpRegFiles    = 'proc????.tmp'
  \  npHRec        = 0
  \  llOpened      = DBUsed (cPathBase + '<<cpNameDataBase>>')
  \  Set Escape On
  \  On Escape Do pZaprosExit
  \  cpTablesString1 = '<<cpTablesString1>>'
  \  cpTablesString2 = '<<cpTablesString2>>'
  \  cpTablesString3 = '<<cpTablesString3>>'
  \  cpTablesString = cpTablesString1 + cpTablesString2 + cpTablesString3
  \  cpIndexExist   = '<<cpIndexExist>>'
  \  cpTablesCP1    = '<<cpTablesCP1>>'
  \  cpTablesCP2    = '<<cpTablesCP2>>'
  \  cpTablesCP     = cpTablesCP1 + cpTablesCP2
  \  Public Array arStructures [npTablesCount]
  \  npRetProv = 0
  \  Do pPrBase
  \  Wait Clear
  \  nlRet = npRetProv
  \  On Key Label ESC
  \  Set Escape &clEscape
  \  If npHRec > 0
  \    = fClose (npHRec)
  \  EndIf
  \  If DBUsed (cPathBase + '<<cpNameDataBase>>')
  \    Set DataBase To (cPathBase + '<<cpNameDataBase>>')
  \    Close DataBases
  \  EndIf
  \  If llOpened
  \    Open DataBase (cPathBase + '<<cpNameDataBase>>') Shared
  \    Set DataBase To (cPathBase + '<<cpNameDataBase>>')
  \  EndIf
  \  Release oLoad, cpTablesString, cpTablesString1, cpTablesString2, cpTablesString3, npTablesCount, cpIndexExist, cpTablesCP, cpTablesCP1, cpTablesCP2;
  \          lpYesSboy, npRetProv, cpRecoverFile, cpRegFiles, npHRec, arStructures, nPrError
  \  Clear Typeahead
  \Return nlRet
  \
Return

*-----------------------------------------------------------------------
*   pMakePrBase
*  :
*         
Procedure pMakePrBase
  \*-----------------------------------------------------------------------
  \*  pPrBase
  \* :
  \*           
  \*      npRetProv
  \Procedure pPrBase
  \  Local lError, lCDX, nlRet
  \  If !File (cPathBase + '<<cpNameDataBase>>') Or !File (cPathBase + '<<StrTran (cpNameDataBase, '.DBC', '.DCT')>>')
  \    npRetProv = -2
  \    Return
  \  EndIf
  \  nlRet = fVersion ()                     &&     
  \  If nlRet < 0                            &&    (-1)
  \    npRetProv = nlRet                     &&    (-10)
  \    Return
  \  EndIf
  \  nlRet = fGetAttrib ()                   &&     "  "
  \  If nlRet < 0
  \    npRetProv = nlRet                     &&   
  \    Return
  \  EndIf
  \  Do pStrucToArray
  \  Do While .T.
  \    lpYesSboy = .F.
  \    Wait '  ...' Window NoWait
  \    If !fFilesExists (.F.) Or fYesSboy () &&    
  \                                          &&       
  \      lpYesSboy = .T.                     &&    
  \    EndIf
  \    If !lpYesSboy                         &&      
  \      nlRet = fNormalAllStruct ()         && .     . 
  \      If nlRet = -10                      &&      
  \        npRetProv = -10
  \        Return
  \      EndIf
  \      If nlRet < 0                        &&  -   . 
  \        lpYesSboy = .T.                   &&    
  \      EndIf
  \    EndIf
  \    If !lpYesSboy                         &&      
  \      nlRet = fNormalAllIndex ()          && .     . 
  \      If nlRet = -10                      &&      
  \        npRetProv = -10
  \        Return
  \      EndIf
  \      If nlRet < 0                        &&    
  \        lpYesSboy = .T.                   &&    
  \      EndIf
  \    EndIf
  \    Wait Clear
  \    If lpYesSboy                          &&     
  \      If Type ('oLoad') <> 'O'
  \        oLoad = CreateObject ('frmLoadApp')
  \        oLoad.Visible = .T.
  \      EndIf
  \      If fBaseRecovering ()               &&    
  \        Do pWaitRecover                   &&  ,  
  \        Loop                              &&    
  \      Else                                &&    
  \        npHRec = fCreate (cPathBase + cpRecoverFile) &&   
  \        npRetProv = fRecoverBase ()       &&   
  \        = fClose (npHRec)
  \        npHRec = 0
  \        Exit
  \      EndIf
  \    Else
  \      Exit
  \    EndIf
  \  EndDo
  \  If npRetProv = 0
  \    Do pCP_Zero                           &&   
  \    On Error lError = .T.
  \      Erase (cPathBase + cpRegFiles)
  \      Erase (cPathBase + cpRecoverFile)
  \    On Error
  \  EndIf
  \Return
  \
Return

*-----------------------------------------------------------------------
*  pMakeRecoverBase
* :
*       
Procedure pMakeRecoverBase
  \*-----------------------------------------------------------------
  \*   fRecoverBase
  \*  :
  \*      
  \*   :
  \*      0 - 
  \*     -4 -   .DBF      
  \*    -10 -     /
  \Function fRecoverBase
  \* !!!!!!!  3     
  \  Public cKey, lPriv
  \  Store '' To cKey
  \  Store .F. To lPriv
  \* !!!!!!!
  \  Local nlRet, Tmp01, Tmp02
  \  nlRet = 0
  \  oLoad.txtMessage.Value = '    ...'
  \  If !fFilesExists (.T.)
  \    Return -4
  \  EndIf
  \  Tmp01 = 'b_Tmp01.tmp'
  \  Tmp02 = 'b_Tmp02.tmp'
  \  Erase (Tmp01)
  \  Erase (Tmp02)
  \  oLoad.txtMessage.Value = '    ...'
  \  On Error Do pErrorEvents With Error (), cPathBase + '<<cpNameDataBase>>', cPathBase + '<<StrTran (cpNameDataBase, '.DBC', '.DCX')>>'
  \    Use (cPathBase + '<<cpNameDataBase>>') In 0 Alias alBase Exclusive
  \  On Error
  \  If !Used ('alBase')
  \    Return -10
  \  EndIf
  \  Select alBase
  \  Locate For Objectname = 'StoredProceduresSource'
  \  If Found ()
  \    Copy Memo Code To (Tmp01)
  \  EndIf
  \  Locate For Objectname = 'StoredProceduresObject'
  \  If Found ()
  \    Copy Memo Code To (Tmp02)
  \  EndIf
  \  oLoad.txtMessage.Value = '   ...'
  \  Delete All For ObjectType = 'Table' Or ObjectType = 'Field' Or ObjectType = 'Index' Or ObjectType = 'Relation' Or ObjectType = 'View'
  \  Pack
  \  Use
  \  nlRet = fMakeIndexes () &&  
  \  If nlRet < 0
  \    Erase (Tmp01)
  \    Erase (Tmp02)
  \    Return nlRet
  \  EndIf
  \  oLoad.txtMessage.Value = '   ...'
  \  nlRet = fMakeConnections ()
  \  If nlRet < 0
  \    Erase (Tmp01)
  \    Erase (Tmp02)
  \    Return nlRet
  \  EndIf
  \  oLoad.txtMessage.Value = '   ...'
  \  nlRet = fMakeViews ()
  \  If nlRet < 0
  \    Erase (Tmp01)
  \    Erase (Tmp02)
  \    Return nlRet
  \  EndIf
  \  oLoad.txtMessage.Value = '   ...'
  \  nlRet = fMakeRelations ()
  \  If nlRet < 0
  \    Erase (Tmp01)
  \    Erase (Tmp02)
  \    Return nlRet
  \  EndIf
  \  oLoad.txtMessage.Value = '    ...'
  \  nlRet = fMakeRI ()
  \  If nlRet < 0
  \    Erase (Tmp01)
  \    Erase (Tmp02)
  \    Return nlRet
  \  EndIf
  \  oLoad.txtMessage.Value = '    ...'
  \  On Error Do pErrorEvents With Error (), cPathBase + '<<cpNameDataBase>>', cPathBase + '<<StrTran (cpNameDataBase, '.DBC', '.DCX')>>'
  \    Use (cPathBase + '<<cpNameDataBase>>') In 0 Alias alBase Exclusive
  \  On Error
  \  If !Used ('alBase')
  \    Erase (Tmp01)
  \    Erase (Tmp02)
  \    Return -10
  \  EndIf
  \  Select alBase
  \  Locate For Objectname = 'StoredProceduresSource'
  \  If Found ()
  \    Append Memo Code From (Tmp01) OverWrite
  \  EndIf
  \  Locate For Objectname = 'StoredProceduresObject'
  \  If Found ()
  \    Append Memo Code From (Tmp02) OverWrite
  \  EndIf
  \  Use
  \  Erase (Tmp01)
  \  Erase (Tmp02)
  \* !!!!!!!      
  \  Release cKey, lPriv
  \* !!!!!!!
  \Return nlRet
  \
Return

*-----------------------------------------------------------------------
*  pMakeStrucToArray
* :
*          
Procedure pMakeStrucToArray
  Local i, i1, nlFields, nlMax
  \*-----------------------------------------------------------------
  \*  pStrucToArray
  \* :
  \*     arStructures      
  \Procedure pStrucToArray
  For i = 1 To npTablesCount &&     
    Use (cpPathDataBase + AllTrim (aAll_Tables [i])) In 0 Alias curTableInBase
    nlFields = aFields (arFields, 'curTableInBase')
    Use In curTableInBase
    nlMax = Len (arFields [1, 1])
    For i1 = 1 To nlFields
      If Len (arFields [i1, 1]) > nlMax
        nlMax = Len (arFields [i1, 1])
      EndIf
    Next
    \  *  <<AllTrim (aAll_Tables [i])>>
    \  arStructures [<<i>>] = ;
    For i1 = 1 To nlFields
      \    '<<PadR (arFields [i1, 1], nlMax)>>;<<arFields [i1, 2]>>;<<PadL (arFields [i1, 3], 3)>>;<<PadL (arFields [i1, 4], 3)>>;'
      If i1 < nlFields
        \\ + ;
      EndIf
    Next
    Release arFields
  Next
  \Return
  \
Return

*-----------------------------------------------------------------------
*  pMakeGetStructure
* :
*       -
Procedure pMakeGetStructure
  \*-----------------------------------------------------------------
  \*  fGetStructure
  \* :
  \*       -
  \* :
  \*   npI -    arStructures
  \Function fGetStructure
  \Parameter npI
  \Return arStructures [npI]
Return

*-----------------------------------------------------------------------
*  pMakeNormalAllIndex
* :
*         
Procedure pMakeNormalAllIndex
  \*-----------------------------------------------------------------
  \*   fNormalAllIndex
  \*  :
  \*            
  \*   :
  \*      0 -   
  \*     -1 - -   
  \*    -10 -      /
  \Function fNormalAllIndex
  \  Local i, nlCount, llOpened, nlRet, nlTags, clFile
  \  llOpened = DBUsed (cPathBase + '<<cpNameDatabase>>')
  \  nlRet    = 0
  \  If !llOpened
  \    On Error Do pErrorEvents With Error (), cPathBase + '<<cpNameDatabase>>', cPathBase + '<<StrTran (cpNameDatabase, '.DBC', '.DCX')>>'
  \      Open DataBase (cPathBase + '<<cpNameDatabase>>') Shared
  \    On Error
  \    If !DBUsed (cPathBase + '<<cpNameDatabase>>')
  \      = MessageBox ('    .', 48, '')
  \      Return -10
  \    EndIf
  \  EndIf
  \  Set DataBase To (cPathBase + '<<cpNameDatabase>>')
  \  For i = 1 To npTablesCount &&     
  \    clFile  = fGetStrBetweenSimv (cpTablesString, i, ';')     &&  
  \    nlCount = Val (fGetStrBetweenSimv (cpIndexExist, i, ';')) &&   
  \    On Error Do pErrorEvents With Error (), cPathBase + clFile + '.dbf', cPathBase + clFile + '.cdx'
  \      Use (cPathBase + clFile) In 0 Alias curTmp Shared Again
  \    On Error
  \    If Used ('curTmp')
  \      Select curTmp
  \      nlTags = TagCount ()
  \      Use
  \      If nlTags < nlCount
  \        nlRet = -1
  \        Exit
  \      Endif
  \    Else
  \      = MessageBox ('    ' + clFile + '  .', 48, '')
  \      nlRet = -10
  \      Exit
  \    EndIf
  \  Next
  \  If !llOpened
  \    Close DataBases
  \  EndIf
  \Return nlRet
  \
Return

*-----------------------------------------------------------------------
*  pMakeNormalAllStruct
* :
*          
Procedure pMakeNormalAllStruct
  \*-----------------------------------------------------------------
  \*   fNormalAllStruct
  \*  :
  \*           
  \*   :
  \*      0 -    
  \*     -1 - -    
  \*    -10 -      /
  \Function fNormalAllStruct
  \  Local i, clFile, nlRet, llOpened, nlRet1
  \  llOpened = DBUsed (cPathBase + '<<cpNameDatabase>>')
  \  nlRet    = 0
  \  If !llOpened
  \    On Error Do pErrorEvents With Error (), cPathBase + '<<cpNameDatabase>>', cPathBase + '<<StrTran (cpNameDatabase, '.DBC', '.DCX')>>'
  \      Open DataBase (cPathBase + '<<cpNameDatabase>>') Shared
  \    On Error
  \    If !DBUsed (cPathBase + '<<cpNameDatabase>>')
  \      = MessageBox ('    .', 48, '')
  \      Return -10
  \    EndIf
  \  EndIf
  \  Set DataBase To (cPathBase + '<<cpNameDatabase>>')
  \  For i = 1 To npTablesCount &&     
  \    clFile = fGetStrBetweenSimv (cpTablesString, I, ';') &&  
  \    On Error Do pErrorEvents With Error (), cPathBase + clFile + '.dbf', cPathBase + clFile + '.cdx'
  \      Use (cPathBase + clFile) In 0 Alias curTmp Shared Again
  \    On Error
  \    If Used ('curTmp')
  \      Select curTmp
  \      nlRet1 = fValidStructure (i, .F.) &&      
  \      Use 
  \      If nlRet1 < 0  &&    
  \        nlRet = -1
  \        Exit
  \      EndIf
  \    Else
  \      If InList (nPrError, 1542, 1561)
  \        nlRet = -1
  \        Exit
  \      EndIf
  \      = MessageBox ('    ' + clFile + '  .', 48, '')
  \      nlRet = -10
  \      Exit
  \    EndIf
  \  Next
  \  If !llOpened
  \    Close DataBases
  \  EndIf
  \Return nlRet
  \
Return

*-----------------------------------------------------------------------
*  pMakeValidStructure
* :
*         
Procedure pMakeValidStructure
  \*-----------------------------------------------------------------
  \*   fValidStructure
  \*  :
  \*         
  \*  :
  \*    npI      -       cpTablesString
  \*    lpChange - .T. -  , .F. -  
  \*   :
  \*     0 -     
  \*    -1 -       
  \*    -2 -      
  \*    -3 -     
  \Function fValidStructure
  \Parameters npI, lpChange
  \  Local nlCount, i, clStru, clFile, clField, clType, nlLen, nlDec, nlPoz, nlRow
  \  clFile  = fGetStrBetweenSimv (cpTablesString, npI, ';') &&  
  \  clStru  = fGetStructure (npI)         && - 
  \  nlCount = aFields (arFCurr)           &&   
  \  For i = 1 To Occurs (';', clStru) / 4 &&    -
  \    clField =      fGetStrBetweenSimv (clStru, i * 4 - 3, ';')  &&  
  \    clType  =      fGetStrBetweenSimv (clStru, i * 4 - 2, ';')  &&  
  \    nlLen   = Val (fGetStrBetweenSimv (clStru, i * 4 - 1, ';')) &&  
  \    nlDec   = Val (fGetStrBetweenSimv (clStru, i * 4    , ';')) && .. 
  \    nlPoz = aScan (arFCurr, clField)
  \    If nlPoz > 0
  \      nlRow = aSubscript (arFCurr, nlPoz, 1)
  \      If clType <> arFCurr [nlRow, 2] Or nlLen <> arFCurr [nlRow, 3] Or nlDec <> arFCurr [nlRow, 4] &&     
  \        If lpChange           &&      
  \          Alter Table (clFile) Alter Column &clField &clType (nlLen, nlDec)
  \        Else
  \          Return -2           &&     
  \        EndIf
  \      EndIf  
  \    Else                      &&        
  \      If lpChange             &&      
  \        Alter Table (clFile) Add Column &clField &clType (nlLen, nlDec)
  \      Else
  \        Return -1             &&     
  \      EndIf
  \    EndIf
  \  Next
  \  For i = 1 To nlCount
  \    clField = arFCurr [i, 1]
  \    nlPoz = (clField $ clStru)
  \    If !nlPoz
  \      If lpChange
  \        Alter Table (clFile) Drop Column &clField
  \      Else
  \        Return -3             &&     
  \      EndIf
  \    EndIf
  \  Next
  \Return 0
  \
Return

*-----------------------------------------------------------------------
*  pMakeCreateTable
* :
*         Create Table
Procedure pMakeCreateTable
  \*-----------------------------------------------------------------
  \*  fCreateTable
  \* :
  \*     Create Table   
  \* :
  \*   cpName -  
  \*   cpStr  -     
  \*  :
  \*   .T. -   , .F. -   
  \Function fCreateTable
  \Parameter cpName, cpStr
  \  Local clStr, i, nlLen, llError
  \  nlLen = Occurs (';', cpStr) / 4
  \  clStr = 'Create Table ' + cPathBase + cpName + ' Free ('
  \  For i = 1 To nlLen
  \    clStr = clStr + ;
  \              fGetStrBetweenSimv (cpStr, i * 4 - 3, ';') + ' '  + ;
  \              fGetStrBetweenSimv (cpStr, i * 4 - 2, ';') + ' (' + ;
  \              fGetStrBetweenSimv (cpStr, i * 4 - 1, ';') + ','  + ;
  \              fGetStrBetweenSimv (cpStr, i * 4    , ';') + ')'
  \    If i < nlLen
  \      clStr = clStr + ','
  \    EndIf
  \  Next
  \  clStr = clStr + ')'
  \  On Error llError = .T.
  \    &clStr
  \  On Error
  \  If !llError
  \    Use
  \  EndIf
  \Return !llError
  \
Return

*-----------------------------------------------------------------------
*  pMakeFilesExists
* :
*         
Procedure pMakeFilesExists
  \*-----------------------------------------------------------------------
  \*  fFilesExists
  \* :
  \*       DBF  CDX   
  \* :
  \*   lpCreate - .T. -   , .F. -   
  \*  :
  \*   .T. -    ( )
  \*   .F. -     (  )
  \Function fFilesExists
  \Parameter lpCreate
  \  Local i, clF, nlI, clStruc
  \  For i = 1 To npTablesCount
  \    clF =      fGetStrBetweenSimv (cpTablesString, i, ';')
  \    nlI = Val (fGetStrBetweenSimv (cpIndexExist,   i, ';'))
  \    If !File (cPathBase + clF + '.DBF')
  \      If !lpCreate
  \        Return .F.
  \      EndIf
  \      clStruc = fGetStructure (i)
  \      If !fCreateTable (clF, clStruc)
  \        Return .F.
  \      Endif
  \    EndIf
  \    If nlI > 0 And !File (cPathBase + clF + '.CDX') And !lpCreate
  \      Return .F.
  \    EndIf
  \  Next
  \Return .T.
  \
Return

*-----------------------------------------------------------------------
*  pMakeYesSboy
* :
*        
Procedure pMakeYesSboy
  \*-----------------------------------------------------------------------
  \* fYesSboy
  \* :
  \*    ,        
  \*  :
  \*   .T. - , .F. -    -   
  \Function fYesSboy
  \Local nF, nH, i, llSboy, nlError
  \  *   ,     
  \  If File (cPathBase + cpRecoverFile)
  \    Return .T.
  \  EndIf
  \  *         
  \  llSboy = .F.
  \  nF = ADir (arTmp, cPathBase + cpRegFiles)
  \  For i = 1 To nF
  \    nH = fOpen (cPathBase + arTmp [i, 1], 12) &&     -
  \    If nH > 0
  \      = fClose (nH)
  \      Release arTmp
  \      llSboy = .T.
  \      Exit
  \    EndIf
  \  Next
  \  Release arTmp
  \  If llSboy
  \    nlError = 0
  \    On Error nlError = Error ()
  \      Use (cPathBase + '<<cpNameDatabase>>') In 0 Alias al_tmp Exclusive
  \      If nlError = 1705
  \        llSboy = .F.
  \      EndIf
  \      Use In al_tmp
  \    On Error
  \  EndIf
  \Return llSboy
  \
Return

*-----------------------------------------------------------------------
*  pMakeIndexes
* :
*             
Procedure pMakeIndexes
  Local i, i1, llOpened, nlNumberOfFields, clCollate, clTag, clFieldAlias, clFieldHeaderAlias, clTemp
  llOpened = DBUsed (cpFullDatabase)
  If !llOpened
    Open DataBase (cpFullDatabase)
  EndIf
  Set DataBase To (cpFullDatabase)
  \*-----------------------------------------------------------------------
  \*   fMakeIndexes
  \*  :
  \*           .
  \*   :
  \*      0 - 
  \*    -10 -    
  \Function fMakeIndexes
  \  Local i, clT, lError
  \  oLoad.txtMessage.Value = '      ...'
  \  On Error Do pErrorEvents With Error (), cPathBase + '<<cpNameDataBase>>', cPathBase + '<<StrTran (cpNameDataBase, '.DBC', '.DCX')>>'
  \    Open DataBase (cPathBase + '<<cpNameDataBase>>') Exclusive
  \  On Error
  \  If !DBUsed (cPathBase + '<<cpNameDataBase>>')
  \    Return -10
  \  EndIf
  \  Set DataBase To (cPathBase + '<<cpNameDataBase>>')
  \  On Error lError = .T.
  \    For i = 1 To npTablesCount
  \      clT = fGetStrBetweenSimv (cpTablesString, i, ';')
  \      Free Table (cPathBase + clT + '.dbf')
  \      Erase (cPathBase + clT + '.cdx')
  \    Next
  \  On Error
  \  oLoad.txtMessage.Value = '      ...'
  \  For i = 1 To npTablesCount
  \    clT = fGetStrBetweenSimv (cpTablesString, i, ';')
  \    Add Table (cPathBase + clT)
  \  Next
  \  Local clFile, clIndex
  For i = 1 To npTablesCount &&     
    Use (aAll_Tables [i]) In 0 Exclusive Alias curTmp
    Select curTmp
    nlNumberOfFields = AFields (aAll_Fields)
    \  *  <<aAll_Tables [i]>>
    \  clFile  = cPathBase + '<<aAll_Tables [i]>>' + '.dbf'
    \  clIndex = cPathBase + '<<aAll_Tables [i]>>' + '.cdx'
    \  On Error Do pErrorEvents With Error (), clFile, clIndex
    \    Use (clFile) In 0 Exclusive Alias <<aAll_Tables [i]>>
    \  On Error
    \  If !Used ('<<aAll_Tables [i]>>')
    \    Return -10
    \  EndIf
    \  Select <<aAll_Tables [i]>>
    \  oLoad.txtMessage.Value = '   <<aAll_Tables [i]>>  ...'
    \  = fValidStructure (<<i>>, .T.) &&       
    \  oLoad.txtMessage.Value = '  <<aAll_Tables [i]>>  ...'
    *  
    \  *  
    For i1 = 1 To nlNumberOfFields
      \  Alter Table (clFile) Alter Column <<aAll_Fields [i1, 1]>> <<IIf (aAll_Fields [i1, 5], '', 'Not ')>>Null
      If !Empty (aAll_Fields [i1, 7])
        \  Alter Table (clFile) Alter Column <<aAll_Fields [i1, 1]>> Set Check <<aAll_Fields [i1, 7]>> <<IIf (Empty (aAll_Fields [i1, 8]), '', ' Error ' + aAll_Fields [i1, 8]))>>
      EndIf
      If !Empty (aAll_Fields [i1, 9])
        \  Alter Table (clFile) Alter Column <<aAll_Fields [i1, 1]>> Set Default <<aAll_Fields [i1, 9]>>
      EndIf
    Next
    * 
    \  * 
    clCollate = ''
    For i1 = 1 To TagCount ()
      clTag = Upper (AllTrim (Tag (i1)))
      If clCollate <> IdxCollate (i1)
        clCollate = IdxCollate (i1)
        \  Set Collate To '<<clCollate>>'
      EndIf
      Do Case
        Case Primary (i1)
          \  Alter Table (clFile) Add Primary Key <<Sys (14, i1)>> Tag <<clTag>>
        Case Candidate (i1)
          \  Index On <<Sys (14, i1)>> Tag <<clTag>>
          If !Empty (Sys (2021, i1))
            \\ For <<Sys (2021, i1)>>
          EndIf
          \\ Candidate
        Case Unique (i1)
          \  Index On <<Sys (14, i1)>> Tag <<clTag>>
          If !Empty (Sys (2021, i1))
            \\ For <<Sys (2021, i1)>>
          EndIf
          \\ Unique
        OtherWise
          \  Index On <<Sys(14, i1)>> Tag <<clTag>>
          If !Empty (Sys (2021, i1))
            \\ For <<Sys (2021, i1)>>
          EndIf
          \\ <<IIf (Descending (i1), ' Descinding ', '')>>
      EndCase
    Next
    If TagCount () > 0
      \  Reindex
    EndIf
  
    *  
    \  *  
    For i1 = 1 To nlNumberOfFields
      clFieldAlias       = aAll_Tables [i] + '.' + aAll_Fields [i1, 1]
      clFieldHeaderAlias = "DBSetProp ('" + clFieldAlias + "', 'Field', "
      clTemp             = DBGetProp (clFieldAlias, 'Field', 'Caption')
      If !Empty (clTemp)
        clTemp = StrTran (clTemp, ["], ['])
        \  <<clFieldHeaderAlias>> 'Caption', '<<clTemp>>')
      EndIf
      clTemp = DBGetProp (clFieldAlias, 'Field', 'Comment')
      If !Empty (clTemp)
        clTemp = StrTran (clTemp, ["], ['])
        clTemp = StrTran (clTemp, Chr (10)) &&    
        clTemp = StrTran (clTemp, Chr (13), '" + Chr (13) + "') &&      
        \  <<clFieldHeaderAlias>> 'Comment', '<<clTemp>>')
      EndIf
      clTemp = DBGetProp (clFieldAlias, 'Field', 'InputMask')
      If !Empty (clTemp)
        clTemp = StrTran (clTemp, ["], ['])
        \  <<clFieldHeaderAlias>> 'InputMask', '<<clTemp>>')
      EndIf
      clTemp = DBGetProp (clFieldAlias, 'Field', 'Format')
      If !Empty (clTemp)
        clTemp = StrTran (clTemp, ["], ['])
        \  <<clFieldHeaderAlias>> 'Format', '<<clTemp>>')
      EndIf
      clTemp = DBGetProp (clFieldAlias, 'Field', 'DisplayClass')
      If !Empty (clTemp)
        clTemp = StrTran (clTemp, ["], ['])
        \  <<clFieldHeaderAlias>> 'DisplayClass', '<<clTemp>>')
      EndIf
      clTemp = DBGetProp (clFieldAlias, 'Field', 'DisplayClassLibrary')
      If !Empty (clTemp)
        clTemp = StrTran (clTemp, ["], ['])
        \  <<clFieldHeaderAlias>> 'DisplayClassLibrary', '<<clTemp>>')
      EndIf
    Next
    clTemp = DBGetProp (aAll_Tables [i], 'Table', 'Comment')
    If !Empty (clTemp)
      clTemp = StrTran (clTemp, ["], ['])
      clTemp = StrTran (clTemp, Chr (10))                    &&    
      clTemp = StrTran (clTemp, Chr (13), '" + Chr(13) + "') &&      
      \  DBSetProp ('<<aAll_Tables [i]>>', 'Table', 'Comment', '<<clTemp>>')
    EndIf
    clTemp = DBGetProp (aAll_Tables [i], 'Table', 'DeleteTrigger')
    If !Empty (clTemp)
      \  Create Trigger On '<<aAll_Tables [i]>>' For Delete As <<clTemp>>
    EndIf
    clTemp = DBGetProp (aAll_Tables [i], 'Table', 'InsertTrigger')
    If !Empty (clTemp)
      \  Create Trigger On '<<aAll_Tables [i]>>' For Insert As <<clTemp>>
    EndIf
    clTemp = DBGetProp (aAll_Tables [i], 'Table', 'UpdateTrigger')
    If !Empty (clTemp)
      \  Create Trigger On '<<aAll_Tables [i]>>' For Update As <<clTemp>>
    EndIf
    clTemp = DBGetProp (aAll_Tables [i], 'Table', 'RuleExpression')
    If !Empty (clTemp)
      clError = DBGetProp (aAll_Tables [i], 'Table', 'RuleText')
      \  Alter Table '<<aAll_Tables [i]>>' Set Check <<clTemp>>
      If !Empty (clError)
        \\ Error <<clError>>
      EndIf
    EndIf
    \  Use 
    Use
    Release aAll_Fields
  Next
  \  Close DataBases
  \Return 0
  \
  If !llOpened
    Close DataBases
  EndIf
Return

*-----------------------------------------------------------------------
*  pMakeConnections
* :
*        
Procedure pMakeConnections
  Local nlConn, llOpened, i
  llOpened = DBUsed (cpFullDatabase)
  If !llOpened
    Open DataBase (cpFullDatabase)
  EndIf
  Set DataBase To (cpFullDatabase)
  nlConn = ADBObjects (aAll_Connections, 'Connection') &&   
  \*-----------------------------------------------------------------------
  \*   fMakeConnections
  \*  :
  \*       .
  \*   :
  \*      0 - 
  \*    -10 -     
  \Function fMakeConnections
  \
  \  On Error Do pErrorEvents With Error (), cPathBase + '<<cpNameDataBase>>', cPathBase + '<<StrTran (cpNameDataBase, '.DBC', '.DCX')>>'
  \    Open DataBase (cPathBase + '<<cpNameDataBase>>') Exclusive
  \  On Error
  \  If !DBUsed (cPathBase + '<<cpNameDataBase>>')
  \    Return -10
  \  EndIf
  \  Set DataBase To (cPathBase + '<<cpNameDataBase>>')
  For i = 1 To nlConn
    \  * <<aAll_Connections [i]>>
    *       
    clAsynchronous   = IIf (         DBGetProp (aAll_Connections [i], 'Connection', 'Asynchronous'  ), '.T.', '.F.')
    clBatchMode      = IIf (         DBGetProp (aAll_Connections [i], 'Connection', 'BatchMode'     ), '.T.', '.F.')
    ccComment        = AllTrim (     DBGetProp (aAll_Connections [i], 'Connection', 'Comment'       ))
    ccConnectString  = AllTrim (     DBGetProp (aAll_Connections [i], 'Connection', 'ConnectString' ))
    cnConnectTimeOut = AllTrim (Str (DBGetProp (aAll_Connections [i], 'Connection', 'ConnectTimeOut')))
    ccDataSource     = AllTrim (     DBGetProp (aAll_Connections [i], 'Connection', 'DataSource'    ))
    cnDispLogin      = AllTrim (Str (DBGetProp (aAll_Connections [i], 'Connection', 'DispLogin'     )))
    clDispWarnings   = IIf (         DBGetProp (aAll_Connections [i], 'Connection', 'DispWarnings'  ), '.T.', '.F.')
    cnIdleTimeOut    = AllTrim (Str (DBGetProp (aAll_Connections [i], 'Connection', 'IdleTimeOut'   )))
    ccPassword       = AllTrim (     DBGetProp (aAll_Connections [i], 'Connection', 'Password'      ))
    cnQueryTimeOut   = AllTrim (Str (DBGetProp (aAll_Connections [i], 'Connection', 'QueryTimeOut'  )))
    cnTransactions   = AllTrim (Str (DBGetProp (aAll_Connections [i], 'Connection', 'Transactions'  )))
    ccUserId         = AllTrim (     DBGetProp (aAll_Connections [i], 'Connection', 'UserId'        ))
    cnWaitTime       = AllTrim (Str (DBGetProp (aAll_Connections [i], 'Connection', 'WaitTime'      )))
    ccDatabase       =               DBGetProp (aAll_Connections [i], 'Connection', 'Database'      )

    clCreateString = 'Create Connection ' + AllTrim (aAll_Connections [i]) + ' ; ' + Chr (13)
    If Empty (AllTrim (ccConnectString))  &&     
      clCreateString = clCreateString + "   DataSource '" + AllTrim (ccDataSource) + "' ; " + Chr (13)
      clCreateString = clCreateString + "   UserID '"     + AllTrim (ccUserId)     + "' ; " + Chr (13)
      clCreateString = clCreateString + "   Password '"   + AllTrim (ccPassword)   + "'"    + Chr (13)
    Else
      clCreateString = clCreateString + "   ConnString '" + AllTrim (ccConnectString) + "'"
    EndIf

    clConDBSetPrefix = "DBSetProp ('" + aAll_Connections [i] + "', 'Connection', "
    clConProps = '****' + Chr (13)
    clConProps = clConProps + clConDBSetPrefix + ['Asynchronous', ]   + clAsynchronous   + [)]  + Chr (13)
    clConProps = clConProps + clConDBSetPrefix + ['BatchMode', ]      + clBatchMode      + [)]  + Chr (13)
    clConProps = clConProps + clConDBSetPrefix + ['Comment', ']       + ccComment        + [')] + Chr (13)
    clConProps = clConProps + clConDBSetPrefix + ['DispLogin', ]      + cnDispLogin      + [)]  + Chr (13)
    clConProps = clConProps + clConDBSetPrefix + ['ConnectTimeOut', ] + cnConnectTimeOut + [)]  + Chr (13)
    clConProps = clConProps + clConDBSetPrefix + ['DispWarnings', ]   + clDispWarnings   + [)]  + Chr (13)
    clConProps = clConProps + clConDBSetPrefix + ['IdleTimeOut', ]    + cnIdleTimeOut    + [)]  + Chr (13)
    clConProps = clConProps + clConDBSetPrefix + ['QueryTimeOut', ]   + cnQueryTimeOut   + [)]  + Chr (13)
    clConProps = clConProps + clConDBSetPrefix + ['Transactions', ]   + cnTransactions   + [)]  + Chr (13)
    clConProps = clConProps + clConDBSetPrefix + ['Database', ']      + ccDatabase       + [')] + Chr (13)
    \  <<clCreateString>>
    \  <<clConProps>>
  Next
  \  Close DataBases
  \Return 0
  \
  If !llOpened
    Close DataBases
  EndIf
  Release aAll_Connections
Return

*-----------------------------------------------------------------------
*  pMakeViews
* :
*        
Procedure pMakeViews
  Local nlViews, llOpened, i, i1
  llOpened = DBUsed (cpFullDatabase)
  If !llOpened
    Open DataBase (cpFullDatabase)
  EndIf
  Set DataBase To (cpFullDatabase)
  nlViews = ADBObjects (aAll_Views, 'View') &&   
  \*-----------------------------------------------------------------------
  \*   pMakeViews
  \*  :
  \*       .    
  \*   :
  \*     0 - 
  \*   -10 -     
  \Function fMakeViews
  \  On Error Do pErrorEvents With Error (), cPathBase + '<<cpNameDataBase>>', cPathBase + '<<StrTran (cpNameDataBase, '.DBC', '.DCX')>>'
  \    Open DataBase (cPathBase + '<<cpNameDataBase>>') Exclusive
  \  On Error
  \  If !DBUsed (cPathBase + '<<cpNameDataBase>>')
  \    Return -10
  \  EndIf
  \  Set DataBase To (cPathBase + '<<cpNameDataBase>>')
  For i = 1 To nlViews &&   
    \  * <<aAll_Views [i]>>
    *       
    m.nSourceType       =               DBGetProp (aAll_Views [i], 'View', 'SourceType'     )
    m.cConnectName      = AllTrim (     DBGetProp (aAll_Views [i], 'View', 'ConnectName'    ))
    m.cSQL              = AllTrim (     DBGetProp (aAll_Views [i], 'View', 'SQL'            ))
    m.cnUpdateType      = AllTrim (Str (DBGetProp (aAll_Views [i], 'View', 'UpdateType'     )))
    m.cnWhereType       = AllTrim (Str (DBGetProp (aAll_Views [i], 'View', 'WhereType'      )))
    m.clFetchMemo       = IIf (         DBGetProp (aAll_Views [i], 'View', 'Fetchmemo'      ), '.T.', '.F.')
    m.clShareConnection = IIf (         DBGetProp (aAll_Views [i], 'View', 'ShareConnection'), '.T.', '.F.')
    m.clSendUpdates     = IIf (         DBGetProp (aAll_Views [i], 'View', 'SendUpdates'    ), '.T.', '.F.')
    m.cnUseMemoSize     = AllTrim (Str (DBGetProp (aAll_Views [i], 'View', 'UseMemoSize'    )))
    m.cnFetchSize       = AllTrim (Str (DBGetProp (aAll_Views [i], 'View', 'FetchSize'      )))
    m.cnMaxRecords      = AllTrim (Str (DBGetProp (aAll_Views [i], 'View', 'MaxRecords'     )))
    m.ccTables          = AllTrim (     DBGetProp (aAll_Views [i], 'View', 'Tables'         ))
    m.clPrepared        = IIf (!Empty ( DBGetProp (aAll_Views [i], 'View', 'Prepared'       )), '.T.', '.F.')
    m.clCompareMemo     = IIf (!Empty ( DBGetProp (aAll_Views [i], 'View', 'CompareMemo'    )), '.T.', '.F.')
    m.clFetchAsNeeded   = IIf (!Empty ( DBGetProp (aAll_Views [i], 'View', 'FetchAsNeeded'  )), '.T.', '.F.')
    m.cParams           = AllTrim (     DBGetProp (aAll_Views [i], 'View', 'ParameterList'  ))
    m.lOffline          =               DBGetProp (aAll_Views [i], 'View', 'Offline'        )
    m.cComment          =               DBGetProp (aAll_Views [i], 'View', 'Comment'        )
    If !Empty (m.cComment)
      m.cComment = StrTran (m.cComment , ["], ['])
      m.cComment = StrTran (m.cComment , Chr (10)) 
      m.cComment = StrTran (m.cComment , Chr (13), '" + Chr (13) + "')
    EndIf
    m.cnBatchUpdateCount = AllTrim (Str (DBGetProp (aAll_Views [i], 'View', 'BatchUpdateCount')))
    clCreateString = 'Create SQL View "' + AllTrim (aAll_Views [i]) + '" ; ' + Chr (13)
    If m.nSourceType != 1  &&    
      clCreateString = clCreateString + '   Remote '
      If !Empty (m.cConnectName)
        clCreateString = clCreateString + 'Connect "' + m.cConnectName + '" ; '+Chr (13)
      EndIf
    EndIf
    clCreateString     = clCreateString + '   As '+ m.cSQL + Chr (13)
    m.cViewDBSetPrefix = "DBSetProp ('" + aAll_Views [i] + "', 'View', "

    \  <<clCreateString>>
    \  <<m.cViewDBSetPrefix>> 'UpdateType',       <<m.cnUpdateType>>)
    \  <<m.cViewDBSetPrefix>> 'WhereType',        <<m.cnWhereType>>)
    \  <<m.cViewDBSetPrefix>> 'FetchMemo',        <<m.clFetchMemo>>)
    \  <<m.cViewDBSetPrefix>> 'SendUpdates',      <<m.clSendUpdates>>)
    \  <<m.cViewDBSetPrefix>> 'UseMemoSize',      <<m.cnUseMemoSize>>)
    \  <<m.cViewDBSetPrefix>> 'FetchSize',        <<m.cnFetchSize>>)
    \  <<m.cViewDBSetPrefix>> 'MaxRecords',       <<m.cnMaxRecords>>)
    \  <<m.cViewDBSetPrefix>> 'Tables',           '<<IIf (Empty (m.ccTables), '', m.ccTables)>>')
    \  <<m.cViewDBSetPrefix>> 'Prepared',         <<m.clPrepared>>)
    \  <<m.cViewDBSetPrefix>> 'CompareMemo',      <<m.clCompareMemo>>)
    \  <<m.cViewDBSetPrefix>> 'FetchAsNeeded',    <<m.clFetchAsNeeded>>)
    \  <<m.cViewDBSetPrefix>> 'FetchSize',        <<m.cnFetchSize>>)
    If !Empty (m.cParams)
      \  <<m.cViewDBSetPrefix>> 'ParameterList',    <<m.cParams>>)
    EndIf
    \  <<m.cViewDBSetPrefix>> 'Comment',          '<<IIf (Empty (m.cComment), '', m.cComment)>>')
    \  <<m.cViewDBSetPrefix>> 'BatchUpdateCount', <<m.cnBatchUpdateCount>>)
    \  <<m.cViewDBSetPrefix>> 'ShareConnection',  <<m.clShareConnection>>)
    If m.lOffline
      \  CreateOffLine ('<<aAll_Views [i]>>')
    EndIf

    Close DataBases
    Use (cpFullDatabase) Again In 0 Alias GenViewCursor Exclusive
    Select GenViewCursor
    Locate For AllTrim (UPPER(GenViewCursor.ObjectName)) == aAll_Views [i] AND GenViewCursor.ObjectType = 'View'
    m.nObjectId = GenViewCursor.ObjectId
    SELECT ObjectName FROM GenViewCursor WHERE GenViewCursor.ParentId = m.nObjectId INTO ARRAY aViewFields
    USE in GenViewCursor
    Open DataBase (cpFullDatabase)
    Set DataBase To (cpFullDatabase)
    IF _TALLY # 0
      FOR i1 = 1 TO ALEN(aViewFields, 1)
        m.cFieldAlias  = aAll_Views [i] + "." + AllTrim (aViewFields(i1, 1))
        m.clKeyField   = IIf (DBGetProp (m.cFieldAlias, 'Field', 'KeyField' ), '.T.', '.F.')
        m.clUpdatable  = IIf (DBGetProp (m.cFieldAlias, 'Field', 'Updatable'), '.T.', '.F.')
        m.ccUpdateName = AllTrim (DBGetProp(m.cFieldAlias, 'Field', 'UpdateName'))
        m.cViewFieldSetPrefix = "DBSetProp ('" + m.cFieldAlias + "', 'Field', "
        \  <<m.cViewFieldSetPrefix>> 'KeyField',   <<m.clKeyField>>)
        \  <<m.cViewFieldSetPrefix>> 'Updatable',  <<m.clUpdatable>>)
        \  <<m.cViewFieldSetPrefix>> 'UpdateName', '<<m.ccUpdateName>>')
        clTemp = DBGETPROP(m.cFieldAlias, 'Field', 'RuleExpression')
        IF !EMPTY(clTemp)
          clTemp = STRTRAN(clTemp, ["], ['])
          \  <<m.cViewFieldSetPrefix>>'RuleExpression', '<<clTemp>>')
        ENDIF
      
        clTemp = DBGETPROP(m.cFieldAlias, 'Field', 'RuleText')
        IF !EMPTY(clTemp)
          clTemp = STRTRAN(clTemp, ["], ['])
          \  <<m.cViewFieldSetPrefix>>'RuleText', '<<clTemp>>')
        ENDIF
        clTemp = DBGETPROP(m.cFieldAlias, "Field", "Caption")
        IF !EMPTY(clTemp)
          clTemp = STRTRAN(clTemp, ["], ['])
          \  <<m.cViewFieldSetPrefix>>'Caption', '<<clTemp>>')
        ENDIF
        clTemp = DBGETPROP(m.cFieldAlias, "Field", "Comment")
        IF !EMPTY(clTemp)
          clTemp = STRTRAN(clTemp, ["], ['])
          *! Strip Line Feeds
          clTemp = STRTRAN(clTemp, CHR(10)) 
          *! Convert Carriage Returns To Programmatic Carriage Returns
          clTemp = STRTRAN(clTemp, CHR(13), '" + CHR(13) + "')
          \  <<m.cViewFieldSetPrefix>>'Comment', '<<clTemp>>')
        ENDIF
        clTemp = DBGETPROP(m.cFieldAlias, "Field", "InputMask")
        IF !EMPTY(clTemp)
          clTemp = STRTRAN(clTemp, ["], ['])
          \  <<m.cViewFieldSetPrefix>>'InputMask', '<<clTemp>>')
        ENDIF
        clTemp = DBGETPROP(m.cFieldAlias, "Field", "Format")
        IF !EMPTY(clTemp)
          clTemp = STRTRAN(clTemp, ["], ['])
          \  <<m.cViewFieldSetPrefix>>'Format', '<<clTemp>>')
        ENDIF
        clTemp = DBGETPROP(m.cFieldAlias, "Field", "DisplayClass")
        IF !EMPTY(clTemp)
          clTemp = STRTRAN(clTemp, ["], ['])
          \  <<m.cViewFieldSetPrefix>>'DisplayClass', '<<clTemp>>')
        ENDIF
        clTemp = DBGETPROP(m.cFieldAlias, "Field", "DisplayClassLibrary")
        IF !EMPTY(clTemp)
          clTemp = STRTRAN(clTemp, ["], ['])
          \  <<m.cViewFieldSetPrefix>>'DisplayClassLibrary', '<<clTemp>>')
        ENDIF
        clTemp = DBGETPROP(m.cFieldAlias, "Field", "DataType")
        IF !EMPTY(clTemp)
          \  <<m.cViewFieldSetPrefix>> 'DataType', '<<clTemp>>')
        ENDIF
        clTemp = DBGETPROP(m.cFieldAlias, "Field", "DefaultValue")
        IF !EMPTY(clTemp)
          clTemp = STRTRAN(clTemp, ["], ['])
          \  <<m.cViewFieldSetPrefix>> 'DefaultValue', '<<clTemp>>')
        ENDIF
      ENDFOR
    ENDIF
  Next
  \  Close DataBases
  \Return 0
  \
  If !llOpened
    Close DataBases
  EndIf
  Release aAll_Connections
Return

*-----------------------------------------------------------------------
*  pMakeRelations
* :
*        .
Procedure pMakeRelations
  Local nlRelations, llOpened, i, cl1, cl2, cl3, nl1, nl2, nl3
  llOpened = DBUsed (cpFullDatabase)
  If !llOpened
    Open DataBase (cpFullDatabase)
  EndIf
  Set DataBase To (cpFullDatabase)
  nlRelations = ADBObjects (aAll_Relations, 'Relation') &&   

  *          -
  If nlRelations > 0
    nl1 = Len (aAll_Relations [1, 1])
    nl2 = Len (aAll_Relations [1, 2])
    nl3 = Len (aAll_Relations [1, 3])
    For i = 1 To nlRelations
      If Len (aAll_Relations [i, 1]) > nl1
        nl1 = Len (aAll_Relations [i, 1])
      EndIf
      If Len (aAll_Relations [i, 2]) > nl2
        nl2 = Len (aAll_Relations [i, 2])
      EndIf
      If Len (aAll_Relations [i, 3]) > nl3
        nl3 = Len (aAll_Relations [i, 3])
      EndIf
    Next
    nl1 = nl1 + 2
  EndIf

  \*-----------------------------------------------------------------------
  \*   fMakeRelations
  \*  :
  \*       
  \*   :
  \*     0 - 
  \*   -10 -     
  \Function fMakeRelations
  \  On Error Do pErrorEvents With Error (), cPathBase + '<<cpNameDataBase>>', cPathBase + '<<StrTran (cpNameDataBase, '.DBC', '.DCX')>>'
  \    Open DataBase (cPathBase + '<<cpNameDataBase>>') Exclusive
  \  On Error
  \  If !DBUsed (cPathBase + '<<cpNameDataBase>>')
  \    Return -10
  \  EndIf
  \  Set DataBase To (cPathBase + '<<cpNameDataBase>>')
  For i = 1 To nlRelations &&   
    cl1 = "'" + aAll_Relations [i, 1] + "'"
    cl1 = PadR (cl1, nl1)
    cl2 = PadR (aAll_Relations [i, 2], nl2)
    cl3 = PadR (aAll_Relations [i, 3], nl3)
    \  Alter Table <<cl1>> Add Foreign Key Tag <<cl3>> References <<cl2>> Tag <<aAll_Relations [i, 4]>>
  Next
  \  Close DataBases
  \Return 0
  \
  If !llOpened
    Close DataBases
  EndIf
  Release aAll_Relations
Return

*-----------------------------------------------------------------------
*  pMakeRI
* :
*       
Procedure pMakeRI
  Local nlRelations, llOpened
  llOpened = DBUsed (cpFullDatabase)
  If !llOpened
    Open DataBase (cpFullDatabase)
  EndIf
  Set DataBase To (cpFullDatabase)
  nlRelations = ADBObjects (aAll_Relations, 'Relation') &&   
  Release aAll_Relations
  Close DataBases
  \*-----------------------------------------------------------------------
  \*  fMakeRI
  \* :
  \*       .    
  \*  :
  \*     0 - 
  \*   -10 -     
  \Function fMakeRI
  If nlRelations = 0
    \Return 0
    \
    If llOpened
      Open DataBase (cpFullDatabase)
      Set DataBase To (cpFullDatabase)
    EndIf
    Return
  EndIf

  Use (cpFullDatabase) Exclusive
  Locate For ObjectType = "Relation" And !Empty (RiInfo)
  If Found ()
    \  On Error Do pErrorEvents With Error (), cPathBase + '<<cpNameDataBase>>', cPathBase + '<<StrTran (cpNameDataBase, '.DBC', '.DCX')>>'
    \    Use (cPathBase + '<<cpNameDataBase>>') In 0 Alias alBase Exclusive
    \  On Error
    \  If !Used ('alBase')
    \    Return -10
    \  EndIf
    \  Select alBase
    Do While Found ()
      *! Have to get the parent name to verify we are adding
      *! Information to the right record.
      m.nParentID = ParentID
      Select ObjectName From (cpFullDatabase) Where ObjectID = nParentID Into Array aTableName
      m.nStart = 1
      m.cITag = ""
      m.cTable = ""
      m.cRTag = ""
      Do While m.nStart <= Len (Property)
        nSize = Asc (SubStr (Property, m.nStart, 1)) +;
               (Asc (SubStr (Property, m.nStart + 1, 1)) * 256) +;
               (Asc (SubStr (Property, m.nStart + 2, 1)) * 256^2) + ;
               (Asc (SubStr (Property, m.nStart + 3, 1)) * 256^3)
        m.nKey = Asc (SubStr (Property, m.nStart + 6, 1))
        Do Case
          Case m.nKey = 13
            m.cITag = SubStr (Property, m.nStart + 7, m.nSize - 8)
          Case m.nKey = 18
            m.cTable = SubStr (Property, m.nStart + 7, m.nSize - 8)
          Case m.nKey = 19
            m.cRTag = SubStr (Property, m.nStart + 7, m.nSize - 8)
        EndCase
        m.nStart = m.nStart + m.nSize
      EndDo
      \  Locate For ObjectType = 'Table' And ObjectName = '<<AllTrim (aTableName (1))>>'
      \  If Found ()
      \    nObjectID = ObjectID
      \    Locate For ObjectType = 'Relation' And '<<m.cITag>>'$Property And '<<m.cTable>>'$Property And '<<m.cRTag>>'$Property And ParentID = nObjectID
      \    If Found ()
      \      Replace RiInfo With '<<RiInfo>>'
      \    EndIf
      \  EndIf
      Continue
    EndDo
    \  Use
    \Return 0
    \
  EndIf
  Use
  If llOpened
    Open DataBase (cpFullDatabase)
    Set DataBase To (cpFullDatabase)
  EndIf
Return

*-----------------------------------------------------------------------
*  pMakeWaitRecover
* :
*         
Procedure pMakeWaitRecover
  \*-----------------------------------------------------------------
  \*   pWaitRecover
  \*  :
  \*        
  \Procedure pWaitRecover
  \  Local nlH, clFile
  \  clFile = cPathBase + cpRecoverFile
  \  oLoad.txtMessage.Value = '    ...'
  \  Do While File (clFile)
  \    Wait '' Window TimeOut 3 &&         
  \    nlH = fOpen (clFile, 12)
  \    If nlH > 0
  \      = fClose (nlH)
  \      Exit
  \    EndIf
  \  EndDo
  \Return
  \
Return

*-----------------------------------------------------------------------
*  pMakeBaseRecovering
* :
*         
Procedure pMakeBaseRecovering
  \*-----------------------------------------------------------------
  \*   fBaseRecovering
  \*  :
  \*          
  \*   :
  \*    .T. -     
  \*    .F. -     
  \Function fBaseRecovering
  \  Local nlH, clFile
  \  clFile = cPathBase + cpRecoverFile
  \  If !File (clFile)
  \    Return .F.
  \  EndIf
  \  nlH = fOpen (clFile, 12)
  \  If nlH > 0
  \    = fClose (nlH)
  \    Erase (clFile)
  \    Return .F.
  \  EndIf
  \Return .T.
  \
Return

*-----------------------------------------------------------------------
*  pMakePCPZero
* :
*           
Procedure pMakePCPZero
  \*-----------------------------------------------------------------------
  \* pCP_Zero
  \* :
  \*          
  \Procedure pCP_Zero
  \  Local i, clF, nlCP
  \  For i = 1 To npTablesCount
  \    clF  = fGetStrBetweenSimv (cpTablesString, i, ';')
  \    nlCP = Val (fGetStrBetweenSimv (cpTablesCP, i, ';'))
  \    = fCP_Zero (cPathBase + clF + '.DBF', nlCP)
  \  Next
  \Return
  \
Return

*-----------------------------------------------------------------------
*  pMakeErrorEvents
* :
*      
Procedure pMakeErrorEvents
  \*-----------------------------------------------------------------------
  \* pErrorEvents
  \* :
  \*           
  \* :
  \*    nErr  -  
  \Procedure pErrorEvents
  \Parameter nErr, pDBF, pCDX
  \  nPrError = nErr
  \  Do Case
  \    Case nErr = 114   && Index does not match the table. Delete the index file and re-create the index
  \      If !Empty (pCDX)
  \        Erase (pCDX)
  \        Retry
  \      Endif
  \    Case nErr = 1705 && File access denide
  \      retOK = .T.
  \      o = CreateObject ('frmRepeat', pDBF)
  \      o.Show ()
  \      Release o
  \      If retOK
  \        Retry
  \      EndIf
  \    Case nErr = 1707 && Structural .CDX file is not found
  \      Retry
  \  EndCase
  \Return
  \
Return

*-----------------------------------------------------------------------
*  pMakeVersion
* :
*        
Procedure pMakeVersion
  *    
  Local llOpened
  llOpened = DBUsed (cpFullDatabase)
  If !llOpened
    Open DataBase (cpFullDatabase)
  EndIf
  Set DataBase To (cpFullDatabase)
  Local clComment
  clComment = Upper (AllTrim (DBGetProp (cpFullDatabase, 'DataBase', 'Comment')))
  If !llOpened
    Close DataBases
  EndIf
  \*-----------------------------------------------------------------
  \*  fVersion
  \* :
  \*       
  \*  :
  \*     0 -   
  \*    -1 -    
  \*   -10 -     
  \Function fVersion
  \Local nNum, lOK1, clCommentSave, clCommentCurr, llOpened
  \  clCommentSave = '<<clComment>>'
  \  llOpened = DBUsed (cPathBase + '<<cpNameDatabase>>')
  \  If !llOpened
  \    On Error Do pErrorEvents With Error (), cPathBase + '<<cpNameDatabase>>', cPathBase + '<<StrTran (cpNameDatabase, '.DBC', '.DCX')>>'
  \      Open DataBase (cPathBase + '<<cpNameDatabase>>') Shared
  \    On Error
  \    If !DBUsed (cPathBase + '<<cpNameDatabase>>')
  \      = MessageBox ('    .', 48, '')
  \      Return -10
  \    EndIf
  \  EndIf
  \  Set DataBase To (cPathBase + '<<cpNameDatabase>>')
  \  clCommentCurr = Upper (AllTrim (DBGetProp ('<<cpNameDatabase>>', 'DataBase', 'Comment')))
  \  clCommentCurr = IIf (Empty (clCommentCurr), ' ', clCommentCurr)
  \  If !llOpened
  \    Close DataBases
  \  EndIf
  \  If clCommentSave == clCommentCurr
  \    Return 0
  \  EndIf
  \  = MessageBox ('   .' + Chr (13) + ': ' + clCommentCurr + '.' + Chr (13) + ': ' + clCommentSave + '.' + Chr (13) + ;
  \                '  "   " BASE_UPD.EXE.', 48, '')
  \Return -1
  \
Return

*-----------------------------------------------------------------------
*  pMakeCPZero
* :
*       
Procedure pMakeCPZero
  \*-----------------------------------------------------------------------
  \*   fCP_Zero
  \*  :
  \*       
  \*  :
  \*    cpFileName -   ,    
  \*    npByte     -  
  \*   :
  \*     0 -   
  \*    -1 -    
  \*    -2 -  
  \*    -3 -     VFP
  \Function fCP_Zero
  \Parameter cpFileName, npByte
  \  Local nlByte, nlTotal, nlH, clBuf, llFound, i, clStr1, clStr2, nlIn, nlOut
  \  nlByte    = IIf (pCount () < 2, 0, npByte)
  \  nlOutByte = nlbyte
  \  nlTotal   = 22 &&     
  \  clStr1    = '437;850;1252;10000;852;866;865;861;895;620;737;857;863;10007;10029;10006;1252;1251;1253;1254;1257;0;'
  \  clStr2    = '1;2;3;4;100;101;102;103;104;105;106;107;108;150;151;152;200;201;203;202;204;0;'
  \  llFound = .F.
  \  For i = 1 To nlTotal
  \    nlIn  = Val (fGetStrBetweenSimv (clStr1, i, ';'))
  \    nlOut = Val (fGetStrBetweenSimv (clStr2, i, ';'))
  \    If nlByte = nlIn Or nlByte = nlOut
  \      If nlByte = nlIn
  \        nlByte = nlOut
  \      EndIf
  \      llFound = .T.
  \      Exit
  \    EndIf
  \  Next
  \  If !llFound
  \    Return -2
  \  EndIf
  \  nlH = fOpen (cpFileName, 2)
  \  If nlH <= 0
  \    Return -1
  \  EndIf
  \  *       FoxPro...
  \  clBuf = fRead (nlH, 32)
  \  If (SubStr (clBuf, 1, 1) = Chr (139) Or SubStr (clBuf, 1, 1) = Chr (203) Or ;
  \      SubStr (clBuf, 31, 1) != Chr (0) Or SubStr (clBuf, 32, 1) != Chr (0))
  \    = fClose (nlH)
  \    Return -3
  \  EndIf
  \  *    29 -  
  \  = fSeek  (nlH, 29)
  \  = fWrite (nlH, Chr (nlByte)) 
  \  = fClose (nlH)
  \Return 0
  \
Return

*-----------------------------------------------------------------------
*  pMakeGetStrBetweenSimv
* :
*         
Procedure pMakeGetStrBetweenSimv
  \*-----------------------------------------------------------------
  \*  fGetStrBetweenSimv
  \* :
  \*    ,      
  \* :
  \*   cpStr   -     
  \*   npSlovo -  ,   
  \*   cpSimv  - -
  \Function fGetStrBetweenSimv
  \Parameter cpStr, npSlovo, cpSimv
  \  Local clStr, nKSlov, nBeg, nEnd
  \  nKSlov = Occurs (cpSimv, cpStr) + 1
  \  If npSlovo > nkSlov
  \    Return ''
  \  EndIf
  \  If nKSlov = 1
  \    clStr = AllTrim (cpStr)
  \  Else
  \    cpStr = AllTrim (cpStr) + cpSimv
  \    nBeg = IIf (npSlovo = 1, 1, At (cpSimv, cpStr, npSlovo - 1) + 1)
  \    nEnd = At (cpSimv, cpStr, npSlovo)
  \    clStr = AllTrim (SubStr (cpStr, nBeg, nEnd - nBeg))
  \  Endif
  \Return clStr
  \
Return

*-----------------------------------------------------------------------
*   pMakeZaprosExit
*  :
*           
Procedure pMakeZaprosExit
  \*-----------------------------------------------------------------------
  \*  pZaprosExit
  \* :
  \*          
  \Procedure pZaprosExit
  \  If MessageBox ('    ?',  256+32+4, '') = 6
  \    npRetProv = -20
  \    Return To fOk_Pr_Base
  \  EndIf
  \Return
  \
Return

*-----------------------------------------------------------------------
*  pMakeClasses
* :
*    
Procedure pMakeClasses
  \*-----------------------------------------------------------------------
  \*   
  \Define Class frmRepeat As Form
  \  AutoCenter = .T.
  \  BorderStyle = 2
  \  BufferMode = 2
  \  Caption = ''
  \  Closable = .F.
  \  ControlBox = .F.
  \  DataSession = 2
  \  FontName = 'MS Sans Serif'
  \  Height = 159
  \  MaxButton = .F.
  \  MinButton = .F.
  \  Name = 'frmRepeat'
  \  ShowTips = .T.
  \  TitleBar = 0
  \  Width = 315
  \  WindowType = 1
  \  nSec = 0
  \  
  \  Add Object Label1 As Label With ;
  \    BackStyle = 0,;
  \    Caption = '!!!',;
  \    FontBold = .T.,;
  \    FontName = 'MS Sans Serif',;
  \    FontSize = 10,;
  \    Height = 20,;
  \    Left = 101,;
  \    Name = 'Label1',;
  \    TabIndex = 1,;
  \    Top = 3,;
  \    Width = 112
  \
  \  Add Object Label2 As Label With ;
  \    BackStyle = 0,;
  \    Caption = '     ',;
  \    FontName = 'MS Sans Serif',;
  \    FontSize = 10,;
  \    Height = 18,;
  \    Left = 33,;
  \    Name = 'Label2',;
  \    TabIndex = 2,;
  \    Top = 29,;
  \    Width = 258
  \
  \  Add Object Label3 As Label With ;
  \    Alignment = 2,;
  \    BackStyle = 0,;
  \    Caption = ' ',;
  \    FontBold = .T. ,;
  \    FontName = 'MS Sans Serif',;
  \    FontSize = 8,;
  \    Height = 18,;
  \    Left = 6,;
  \    Name = 'Label3',;
  \    TabIndex = 3,;
  \    Top = 45,;
  \    Width = 306
  \
  \  Add Object Label4 As Label With ;
  \    Alignment = 2,;
  \    BackStyle = 0,;
  \    Caption = '    ',;
  \    FontName = 'MS Sans Serif',;
  \    FontSize = 10,;
  \    Height = 18,;
  \    Left = 2,;
  \    Name = 'Label4',;
  \    TabIndex = 4,;
  \    Top = 72,;
  \    Width = 311
  \
  \  Add Object Label5 As Label With ;
  \    Alignment = 2,;
  \    BackStyle = 0,;
  \    Caption = ' ',;
  \    FontBold = .T. ,;
  \    FontName = 'MS Sans Serif',;
  \    FontSize = 10,;
  \    Height = 18,;
  \    Left = 84,;
  \    Name = 'Label5',;
  \    TabIndex = 5,;
  \    Top = 87,;
  \    Width = 146
  \
  \  Add Object cmdExit As CommandButton With ;
  \    Caption = '', ;
  \    FontName = 'MS Sans Serif',;
  \    FontSize = 8,;
  \    Height = 26, ;
  \    Left = 115, ;
  \    Name = 'cmdExit', ;
  \    TabIndex = 6,;
  \    Top = 119, ;
  \    Width = 84
  \
  \  Add Object Timer1 As Timer With ;
  \    Height = 23,;
  \    Interval = 1000,;
  \    Left = 264,;
  \    Name = 'Timer1',;
  \    Top = 120,;
  \    Width = 23
  \
  \  Procedure Init
  \    Parameter cName
  \    ThisForm.Label3.Caption = cName
  \    ThisForm.Label5.Caption = '15 '
  \  Return
  \  
  \  Procedure Increment
  \    ThisForm.nSec = ThisForm.nSec + 1
  \    If ThisForm.nSec = 15
  \      ThisForm.nSec = 0
  \      If ThisForm.QueryUnload()
  \        ThisForm.Release
  \      EndIf
  \    Else
  \      Local nSec1
  \      nSec1 = 15 - ThisForm.nSec
  \      cSec1 = AllTrim (Str (nSec1))
  \      Do Case
  \        Case InList (nSec1, 15, 14, 13, 12, 11, 10, 9, 8, 7, 6, 5)
  \          ThisForm.Label5.Caption = cSec1 + ' '
  \        Case InList (nSec1, 4, 3, 2)
  \          ThisForm.Label5.Caption = cSec1 + ' '
  \        Case nSec1 = 1
  \          ThisForm.Label5.Caption = cSec1 + ' '
  \      EndCase
  \    EndIf
  \  Return
  \
  \  Procedure cmdExit.Click
  \    retOK = .F.
  \    If ThisForm.QueryUnload()
  \      ThisForm.Release
  \    EndIf
  \  Return
  \  
  \  Procedure Timer1.Timer
  \    ThisForm.Increment
  \  Return
  \EndDefine
  \
  \*-----------------------------------------------------------------------
  \Define Class frmLoadApp As Form
  \  AutoCenter = .T.
  \  BorderStyle = 2
  \  Caption = ''
  \  ControlBox = .F.
  \  DataSession = 2
  \  FontName = 'MS Sans Serif'
  \  FontSize = 8
  \  Height = 324
  \  TitleBar = 0
  \  Width = 556
  \  
  \  Add Object Image1 As Image With ;
  \    Height = 126,;
  \    Left = 22,;
  \    Name = 'Image1',;
  \    Picture = 'c:\work\all\asp_bmp\soft.bmp',;
  \    Top = 24,;
  \    Width = 126
  \
  \  Add Object Label4 As Label With ;
  \    AutoSize = .T.,;
  \    BackStyle = 0,;
  \    Caption = '   :',;
  \    FontName = 'Arial',;
  \    FontSize = 14,;
  \    Height = 25,;
  \    Left = 160,;
  \    Name = 'Label4',;
  \    TabIndex = 1,;
  \    Top = 40,;
  \    Width = 355
  \    
  \  Add Object txtMessage As TextBox With ;
  \    DisabledForeColor = RGB (0,0,128),;
  \    Enabled = .F.,;
  \    FontName = 'Arial',;
  \    Height = 23,;
  \    Left = 166,;
  \    Name = 'txtMessage',;
  \    TabIndex = 2,;
  \    Top = 72,;
  \    Width = 360
  \    
  \  Add Object Label5 As Label With ;
  \    AutoSize = .T.,;
  \    BackStyle = 0,;
  \    Caption = ' ...',;
  \    FontName = 'Arial',;
  \    FontSize = 22,;
  \    ForeColor = RGB (0,0,128),;
  \    Height = 36,;
  \    Left = 195,;
  \    Name = 'Label5',;
  \    TabIndex = 6,;
  \    Top = 126,;
  \    Width = 316
  \
  \  Add Object Label1 As Label With ;
  \    AutoSize = .T.,;
  \    BackStyle = 0,;
  \    Caption = cpCapMain,;
  \    FontName = 'Arial',;
  \    FontSize = 22,;
  \    Height = 36,;
  \    Left = 81,;
  \    Name = 'Label1',;
  \    TabIndex = 3,;
  \    Top = 178,;
  \    Width = 387
  \
  \  Add Object Label2 As Label With ;
  \    AutoSize = .T.,;
  \    BackStyle = 0,;
  \    Caption = ':  "-"',;
  \    FontName = 'Arial',;
  \    FontSize = 22,;
  \    Height = 36,;
  \    Left = 68,;
  \    Name = 'Label2',;
  \    TabIndex = 4,;
  \    Top = 222,;
  \    Width = 412
  \
  \  Add Object lblVersion As Label With ;
  \    AlignMent = 2,;
  \    BackStyle = 0,;
  \    Caption = ' ',;
  \    FontName = 'Arial',;
  \    FontSize = 18,;
  \    Height = 30,;
  \    Left = 52,;
  \    Name = 'lblVersion',;
  \    TabIndex = 5,;
  \    Top = 267,;
  \    Width = 443
  \
  \  Procedure Init
  \    ThisForm.lblVersion.Caption = cVersion
  \  Return
  \EndDefine
  \
Return

*-------------------------    ---------------

*-----------------------------------------------------------------------
*   pGenExit
*  :
*     ,     
*  :
*    lpOK - .T. -  , .F. -   
Procedure pGenExit
Parameter lpOK
  Set TextMerge Off
  Set TextMerge To
  On Error
  If !Empty (cpFullDatabase)
    If DBUsed (cpFullDatabase)
      Set DataBase To (cpFullDatabase)
      Close DataBases
    EndIf
  EndIf
  If lpOK
    Compile (cpOutFile)
  EndIf
  Set Default To (cpOldCurrent)
  Release cpFullDatabase, cpNameDatabase, cpPathDataBase, cpOutFile, cpOldCurrent, ;
          npTablesCount, cpTablesString, aAll_Tables, cpIndexExist, cpTablesCP
Return

*-----------------------------------------------------------------------
*  fGetIndexes
* :
*             
Function fGetIndexes
  Local llOpened, i, clStr
  llOpened = DBUsed (cpFullDatabase)
  If !llOpened
    Open DataBase (cpFullDatabase)
  EndIf
  Set DataBase To (cpFullDatabase)
  clStr = ''
  For i = 1 To npTablesCount
    Use (aAll_Tables [i]) In 0 Alias curTmp Exclusive
    Select curTmp
    clStr = clStr + AllTrim (Str (TagCount ())) + ';'
    Use
  Next
  If !llOpened
    Close DataBases
  EndIf
Return clStr

*-----------------------------------------------------------------------
*  fGetCodePages
* :
*            
Function fGetCodePages
  Local llOpened, i, clStr, clStr1, clStr2
  llOpened = DBUsed (cpFullDatabase)
  Store '' To clStr, clStr1, clStr2
  If !llOpened
    Open DataBase (cpFullDatabase)
  EndIf
  Set DataBase To (cpFullDatabase)
  clStr = ''
  For i = 1 To npTablesCount
    Use (aAll_Tables [i]) In 0 Alias curTmp Exclusive
    Select curTmp
*    If i < 50
      clStr1 = clStr1 + AllTrim (Str (cpDBF ())) + ';'
*    Else
*      clStr2 = clStr2 + AllTrim (Str (cpDBF ())) + ';'
*    EndIf
    Use
  Next
  If !llOpened
    Close DataBases
  EndIf
*  clStr = clStr1 + clStr2
Return clStr1

*-----------------------------------------------------------------------
*   pGenDBC_Error
*  :
*      
*  :
*    cpMess   -   
*    npLineNo -  ,  
Procedure pGenDBC_Error
LParameters cpMess, npLineNo
  Do pErrorMessage With ' : ' + Chr (13) + cpMess + Chr (13) + ' : ' + AllTrim (Str (npLineNo))
  Do pGenExit With .F.
  Cancel
Return

*-----------------------------------------------------------------------
*   pErrorMessage
*  :
*       
Procedure pErrorMessage
Parameter cpAlert_Message
  = MessageBox (cpAlert_Message, 16, ' MyGenDBC...')
Return

*-----------------------------------------------------------------------
*   fGetBase
*  :
*              
*  :
*    cpDefaultBase -  ,    
Function fGetBase
Parameter cpDefaultBase
  If !Empty (cpDefaultBase)
    If fCorrectDataBase (@cpDefaultBase) &&  ,    
      Return cpDefaultBase
    Else
      Do pErrorMessage With '      '
    EndIf
  EndIf

  Local clStr
  clStr = DBC ()  &&     
  If fCorrectDataBase (@clStr)
    Return clStr
  EndIf

  clStr = GetFile ('DBC', '  ...', '...', 0)
  If Empty (clStr)
    Do pErrorMessage With '   '
    Return ''
  EndIf
  
  If !fCorrectDataBase (@clStr)
    Do pErrorMessage With '   '
    Return ''
  EndIf
Return clStr

*-----------------------------------------------------------------------
*   fGetOutFile
*  :
*              
*  :
*    cpDefaultFile -  ,    
Function fGetOutFile
Parameter cpDefaultFile
  If !Empty (cpDefaultFile)
    If fCorrectOutFile (@cpDefaultFile)
      Return cpDefaultFile
    Else
      Do pErrorMessage With '     '
    EndIf
  EndIf
  Local clStr
  clStr = PutFile ('  -...', (SubStr (cpNameDatabase, 1, Rat ('.', cpNameDatabase)) + 'PRG'), 'PRG')
  If Empty (clStr)
    Do pErrorMessage With '  -'
    Return ''
  EndIf
  If !fCorrectOutFile (@clStr)
    Do pErrorMessage With '  -'
    Return ''
  EndIf
Return clStr

*-----------------------------------------------------------------------
*   fCorrectDataBase
*  :
*       
*  :
*    cpBase -      
Function fCorrectDataBase
Parameter cpBase
  If Empty (cpBase)
    Return .F.
  EndIf
  If Upper (Right (cpBase, 4)) <> '.DBC'
    cpBase = cpBase + '.DBC'
  EndIf
  If !File (cpBase)
    Return .F.
  EndIf
  Local llError, clOldError
  llError = .F.
  clOldError = On ('Error')
  On Error llError = .T.
  Open DataBase (cpBase) Shared
  Set DataBase To (cpBase)
  Close DataBases
  If Empty (clOldError)
    On Error
  Else
    On Error &clOldError
  EndIf
Return !llError

*-----------------------------------------------------------------------
*   fCorrectOutFile
*  :
*       
*  :
*    cpBase -     
Function fCorrectOutFile
Parameter cpOutFile
  If Empty (cpOutFile)
    Return .F.
  EndIf
  If Upper (Right (cpOutFile, 4)) <> '.PRG'
    cpOutFile = cpOutFile + '.PRG'
  EndIf
  Local hlFile
  hlFile = FCreate (cpOutFile)
  If hlFile <= 0
    Return .F.
  EndIf
  = fClose (hlFile)
  Erase (cpOutFile)
Return .T.
*-------------------------    ---------------
